#include <iostream>
using namespace std;

//Questo programma calcola la mappa di rinormalizzazione per le decorazioni omogenee totalmente simmetriche
//L'output e` in una forma comprensibile dal programma opensource MAXIMA (http://maxima.sourceforge.net/)

//Il codice non e` una perla di eleganza, ma funziona ed e` abbastanza ben commentato
const char* alphabet="0123456789!@#$%";

int *youngtab; 
int *stateTab;
int *coeff;

int *youngVar;
int numVar,maxVar;
int N;

int *youngCoeff;
int numCoeff,maxCoeff;
int M;


int factorial (int n)
{
  if (n==0) return 1; else return n*factorial(n-1);
}

void swap(int *a,int*b)
{
  int y=*a;
  *a=*b;
  *b=y;
}

// Questa funzione mescola i <len> interi in <array> usando la permutazione indicizzata da p
//  BUGGY CODE: p DEVE essere piu` piccolo di <len>! (buffer overflow) 

void permuta (int p, char* array, int len)
{                                 //Grazie Miri!! Questo e` opera tua!
  if (len==1) return;
  int a1=p/(factorial(len-1));                 //a1 e` la posizione dell'item scelto
  int temp=array[a1];                          //temp e` il valore dell'item scelto
  for (int i=a1;i>0;i--) array[i]=array[i-1];  // Ordina gli item rimanenti
  array[0]=temp;                               //e poni il primo uguale a quello scelto
  permuta(p%(factorial(len-1)),array+1,len-1); // poi continua a permutare quelli che rimangono
  return;
}

int young(int n, int maxCol, int maxRow, int row=0)
{
  //Comincio a riempire la tabella (o quello che ne rimane) dal massimo numero
  //di colonne consentito.
  for (int j=min(n,maxCol);j>0;j--) {
    youngtab[row]=j;
    if (maxRow>row) //Controllo di non usare troppi stati
      if (n-j>0) young(n-j,j,maxRow,row+1); //se avanzano stati e spin, posso ricorrere
      else //Ho finito, scrivo la tabella cosi` ottenuta
	{ 
	  numVar++;
	  if (numVar>maxVar) 
	    {
	      int * temp=new int[N*numVar];
	      memcpy(temp,youngVar,N*maxVar*sizeof(int));
	      maxVar=numVar;
	      delete youngVar;
	      youngVar=temp;
	    }
	  memset(&youngVar[N*(numVar-1)],0,N*sizeof(int));
	  memcpy(&youngVar[N*(numVar-1)],youngtab,(row+1)*sizeof(int));
	}
  } 

    return 0;
}

int youngField(int n, int maxCol, int maxRow, int maxField, int row=0)
{
  for (int j=min(n,maxCol);j>(maxField>row?-1:0);j--) {
    coeff[row]=j;
    if (maxRow>row) 
      if (n-j>0) 
	if (maxField>row) //Ci sono ancora variabili con campo
	  youngField(n-j,n-j,maxRow,maxField,row+1); else  //Finite le variabili con campo!
	    youngField(n-j,j,maxRow,maxField,row+1);
      else // Finito! ora scrivo la tabella
	{ 
	  numCoeff++;
	  if (numCoeff>maxCoeff) 
	    {
	      int * temp=new int[M*numCoeff];
	      memcpy(temp,youngCoeff,M*maxCoeff*sizeof(int));
	      maxCoeff=numCoeff;
	      delete youngCoeff;
	      youngCoeff=temp;
	    }
	  memset(&youngCoeff[M*(numCoeff-1)],0,M*sizeof(int));
	  memcpy(&youngCoeff[M*(numCoeff-1)],coeff,(row+1)*sizeof(int));
	}
  }
    return 0;
}




int main()
{

  int q;   //q di Potts 
  int n;   //Ordine gerarchico
  int m;   //Numero di nuovi spin
  int b;   //Numero di aggregazione (=# di legami)

  cout<<">Thesis< | Reno-rmalization\n This program works ONLY for fully symmetric decorations\n";
  cout<<"Insert n (hierarchy order):";  
  cin>>n;
  
  //A questo punto devo determinare le variabili da usare. 
  //Devo trovare tutti i diagrammi di Young di ordine n e 
  //salvarli da qualche parte

  
  youngtab=new int[n];    // Variabile ausiliaria.
  youngVar=new int[n];    //
  stateTab=new int[n];
  numVar=0;maxVar=1;N=n;  //numVar sara` il numero di variabli trovate
  young(n,n,n);
  cout<<"Young variables:"<<numVar<<"\n";

  cout<<"Insert m (number of inner spins):";
  cin>>m;
  cout<<"Insert b (aggregation number):"; //Griffiths & Kaufman  
  cin>>b;
  cout<<"\n Boundary spins are labeled as:";
  for (int i=0;i<n;i++) cout<<(char)('a'+i);  //Possibile integer overflow
  cout<<"\n Inner spins are labeled as:";
  for (int i=0;i<m;i++) cout<<(char)('a'+n+i);  //Possibile integer overflow
  char* decoration=(char*)(new char[n*b]);
  char temp[256];                            //Possibile buffer overflow
  cout<<"\nInsert the decoration:\n";
  for (int i=0;i<b;i++) {
    cout<<i<<":";
    cin>>temp; //POSSIBILE BUFFER OVERFLOW
    memcpy(&decoration[i*n],temp,n);
  } 
  
  char * state=new char[n+m];
  char * boundaryState=state;
  char * innerState=state+n;

  
  cout<<"\nStart.\n";
  for (int variable=0;variable<numVar;variable++) // Devo trovare la mappa per ciascuna variabile di young
    {
      int bstate=0;int extState=0;
      bool done=false;
      int row=0;
      while (bstate<N) //Una volta assgnati gli stati agli N spin siamo a posto.
	{
	  int spinrow=youngVar[variable*N+row];  //Numero di spin con lo stesso stato extState
	  for (int aux=0;aux<spinrow;aux++) boundaryState[bstate++]=extState; // Assegna gli stati esterni
	  row++;      //Cambia riga
	  extState++; //Cambia stato
	}
      cout<<"P["<<variable<<"]=";
 
      // Per calcolare la decorazione devo sommare sulle configurazioni degli spin interni.
      // Le configurazioni rilevanti sono quelle relative ai diagrammi di young con un numero 
      // di stati speciali pari al numero di righe del diagramma relativo alla variabile che 
      //stiamo considerando.

      coeff=new int[m+row];    // Variabile aux.
      youngCoeff=new int[m+row];    //
      numCoeff=0;maxCoeff=1;M=m+row;  //
      youngField(m,m,M,row);

      // In youngCoeff ora ci sono le tabelle di young speciali di cui al commento precedente
      // La parte difficile e` la combinatorica; e` semplice assegnare i pesi dipendenti da q,
      // ma e` difficile assegnare gli stati interni in maniera opportuna
      // il modo piu` facile (ma *piu` lento*) per fare questo e` di calcolare ogni possibile 
      // permutazione delle assegnazioni e poi dividere per le assegnazioni ripetute. Quindi 
      // il problema si riduce a calcolare il numero delle possibili ripetizioni
      // Tale numero e` il prodotto di:
      // prodotto del fattoriale del numero di quadrati di ogni riga
      // e 
      // prodotto del fattoriale del numero di righe con lo stesso numero di quadrati
      // (tranne per gli stati speciali)

      for (int c=0;c<numCoeff;c++) 
	{
	   int stupid=1;
	   for (int r=0;r<M;r++) stupid*=factorial(youngCoeff[M*c+r]);  //La riga
	   for (int s=1;s<m+1;s++) 
	     {  // Cicla sul numero di quadrati in una riga
	       int howmuch=0;
	       for (int r=row;r<M;r++) 
		 if (youngCoeff[M*c+r]==s) howmuch++;   //Cicla sugli stati non speciali
	       stupid*=factorial(howmuch);
	     }

	   cout <<"(1/"<<stupid<<")*";
	   
	   for (int r=row;r<M;r++) if (youngCoeff[M*c+r]>0) cout<<"(q-"<<r<<")*";
	   cout <<"(";

	   // Ora sappiamo il numero di permutazioni ridondanti,
	   // dobbiamo assegnare gli stati agli spin interni
	   // Prima di tutto li assegnamo in ordine

	   char * innerSorted=new char[m];
	   int inCount=0;
	   for (int r=0;r<M;r++) 
	     for (int count=0; count<youngCoeff[M*c+r];count++) 
	       innerSorted[inCount++]=r; // Assegna lo stato all'inner spin.

	   // Poi per ogni permutazione fissiamo lo stato nel buffer innerState;
	   for (int perm=0;perm<factorial(m);perm++) 
	     { 
	       memcpy(innerState,innerSorted,m*sizeof(char));
	       permuta(perm,innerState,m); 

	       //Ora abbiamo lo stato giusto al posto giusto. Dobbiamo calcolare l'energia
	       //sommiamo sui legami..
	       for (int edge=0;edge<b;edge++) 
		 {
		   // Bisogna trovare il diagramma corrispondente.
		   // prima si costruisce il diagramma nella var youngtab

		   int knownStates=0;
		   for (int i=0;i<n;i++) youngtab[i]=0;
		   for (int spin=0;spin<n;spin++)
		     {
		       int st=state[int(decoration[edge*n+spin])-(int('a'))]; // stato dello spin indexed by <spin>
		       //Controlla se e` noto
		       bool known=false;
		       int knownCounter=0;
		       while ((!known) && (knownCounter<knownStates)) 
			 if (stateTab[knownCounter++]==st) known=true; // controlla se e` noto lo stato
		       if (!known) stateTab[knownStates++]=st;
		       else knownCounter--; // se no aggiungilo alla lista degli stati noti
		       youngtab[knownCounter]++;
		     }
		   //Ora bisogna ordinare la tabella
		   //Lo facciamo in un modo estremamente stupido
		   int counter=0;

		   for (int l=n;l>0;l--) 
		     for (int i=0;i<n;i++) 
		       if (youngtab[i]==l) 
			 swap(youngtab[counter++],youngtab[i]);

		   //Ora abbiamo in youngtab la tabella di young giusta; bisogna trovare
		   //a quale variabile corrisponde
		   counter=0;
		   bool found=false;
		   while (!found) 
		     {
		       found=true;
		       for (int i=0;i<n;i++) if (youngtab[i]!=youngVar[counter*n+i]) found=false;
		       counter++;
		     }
		   counter--;
		   
		   // Abbiamo finito!
		   cout<<"w["<<counter<<"]*";
		 }
	       cout<<"1+";
	       
	     }
	   cout <<"0)+";
	}
      cout << "0;\n"; 
      delete coeff;
      delete youngCoeff;
    }
    


  //Fulgida
  delete youngVar;
  delete youngtab; 
  delete stateTab;
  delete state;
}
